import std/[times, strutils, sequtils, options]

type Ticket = array[5, uint8]

proc to_ticket(s: seq[int]): Ticket =
  for i, n in result.mpairs:
    n = s[i].uint8

proc parse_ticket(l: string): Option[Ticket] =
  let candidate = l.split(' ', 5).map(parseInt).filterIt(it <= 90 and it > 0)
  if candidate.len < 5:
    return Ticket.none
  candidate.to_ticket().some()

proc num_matches(t1: Ticket, t2: Ticket): uint =
  for n1 in t1:
    for n2 in t2:
      if n1 == n2:
        result.inc

let startTime = cpuTime()
echo "Starting..."
const NUM_ENTRIES = 10_000_000
var entries = newSeqOfCap[Ticket] NUM_ENTRIES

for l in "/mytmpfs/10m-v2.txt".lines:
  let t = l.parse_ticket
  if t.isSome:
    entries.add t.get

echo "Parse time taken: ", (cpuTime() - startTime), " seconds"

let winning: Ticket = [68, 81, 40, 34, 85]
let countTime = cpuTime()
var winners: array[6, uint] = [0, 0, 0, 0, 0, 0]
for n in entries:
  winners[n.num_matches(winning)].inc
echo winners, "\nTime taken: ", (cpuTime() - countTime), " seconds"
